package com.seeshiontech.vecloudsdk;

import com.alibaba.fastjson.JSON;

import java.util.HashMap;

public class ClipVideo extends Request {

    String remoteUrl = "/render/charge/cpr/clip";
    private HashMap<String, Object> taskData;

    public HashMap<String, String> cprApiRule = new HashMap<String, String>() {{
        put("recordId", "required|string");
        put("ossId", "required|string");
        put("notifyUrl", "required|string");
        put("uploadKey", "required|string|^\\/.*"); // Upload Key 不能以/开头
        put("videoClips", "required|array");
        put("width", "required|int");
        put("height", "required|int");
        put("frameRate", "required|float");
        put("bitrateControl", "any|float");

    }};

    public ClipVideo(Config config) {
        super(config);
    }

    public HashMap<String, Object> getTaskData() {
        return taskData;
    }

    public String submit() {
        String taskJson = (JSON.toJSONString(this.taskData));
        return super.submitTask(taskJson, remoteUrl);
    }


    /**
     * 设置任务数据，如果任务参数有错误，会抛出异常
     */
    public boolean setTaskData(HashMap<String, Object> taskData) throws Exception {
        taskData.put("ossId", config.getOssId());
        boolean check = checkParamValid(taskData, this.cprApiRule);
        if (check) {
            this.taskData = taskData;
        }
        return check;
    }
}
