package com.seeshiontech.vecloudsdk;

public enum RenderType {
    COMMON_TEMPLATE(1),
    DYNAMIC_TEMPLATE(2),
    FILTER(4),
    CUSTOM_TEMPLATE(8),
    IMAGE_FILTER(16),
    CLIP(32),
    CAMERA_TEMPLATE(256),
    POWER_TEXT(512);

    private int value;

    RenderType(int value) {
        this.value = value;
    }


    public int getValue()
    {
        return this.value;
    }
    /****
     * 返回的是该值的数位(对数+1)，而不是值本身
     * @return
     */
    public int getDigit()
    {
        double digit = Math.log(this.value)/Math.log(2);
        return new Double(digit).intValue() + 1;
    }

}
