package vesdktest;


import com.seeshiontech.vecloudsdk.ClipVideo;
import com.seeshiontech.vecloudsdk.Config;
import com.seeshiontech.vecloudsdk.RenderType;
import org.junit.Test;
import com.seeshiontech.vecloudsdk.Cpr;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.UUID;

/****
 * Author : -
 */
public class RequestTest {
    //您在VE平台的公钥
    private String accessKey = "";
    //您在VE平台的私钥
    private String accessSecret = "";
    //您在VE平台的productId
    private String productId = "";
    //您在VE平台配置的云存储id
    private String ossId = "";
    /****
     * 提交渲染任务接口文档 http://www.seeshiontech.com/docs/page_12.html (一定要看)
     *
     */
    @Test
    public void testRequest() {
        Config config = new Config(accessKey, accessSecret, productId, ossId);

        HashMap<String, Object> taskData = new HashMap<String, Object>();
        HashMap<String, Object> subText = new HashMap<String, Object>();

        subText.put("img_path", "https://vei-oss1.atvideo.cc/photo_relay_album/14_113e983b1804b2af2d27bcdd31d594a7.jpg");
        subText.put("d_key_prefix", "dtext");
        String[] d_texts = {"test"};
        subText.put("d_texts", d_texts);
        ArrayList<HashMap<String, Object>> subTexts = new ArrayList<HashMap<String, Object>>() {{
            this.add(subText);
        }};
        ArrayList<String> assetUrls = new ArrayList<String>(){{
            this.add("https://vei-oss1.atvideo.cc/photo_relay_album/14_113e983b1804b2af2d27bcdd31d594a7.jpg");
        }};
        String recordId = UUID.randomUUID().toString().replace("-", "");


        taskData.put("tplId", 18);
        taskData.put("tplType", 2);
        taskData.put("tplVersion", 11);
        taskData.put("tplUrl", "https://ve-oss1.atvideo.cc/ve/template/jlxc1_4.zip");
        taskData.put("recordId", recordId); //该段商户订单号请您生成，确保唯一
        taskData.put("musicUrl", "http://static.seeshiontech.com/photo_relay_album/video/yp_1.mp3");
        taskData.put("musicLoop", 1);
        taskData.put("ossId", config.getOssId());
        //'
        taskData.put("notifyUrl", "http://veapi.atvideo.cc/sys/save_request?a=1");
        taskData.put("uploadKey", "user_video/" + recordId + ".mp4"); //视频渲染完毕后保存到您的oss平台中的路径
        taskData.put("subTexts", subTexts);
        taskData.put("assetUrls", assetUrls);


        //replaceableJson 该参数存在时，引擎会自动忽略assetUrls、subTexts、subAssetUrls
        //详情查看文档 http://www.seeshiontech.com/docs/page_12.html
        HashMap<String, Object> replace1 = new HashMap<String, Object>();
        replace1.put("d_key_prefix", "dtext");
        replace1.put("type", 1);
        replace1.put("file", "http://static.atvideo.cc/kebentuya/1.jpeg");

        HashMap<String, Object> replace2 = new HashMap<String, Object>();
        replace2.put("d_key_prefix", "dtext");
        replace2.put("type", 2);
        replace2.put("text", "字幕四，居中");

        ArrayList<Object> replaces = new ArrayList<Object>(){{
                this.add(replace1);
                this.add(replace2);
            }};
        HashMap<String, Object> replaceJson = new HashMap<String, Object>();
        replaceJson.put("replaces", replaces);
        replaceJson.put("main_file", "https://ve-img-src.atvideo.cc/meipian/img/3.jpeg");
        ArrayList<Object> replaceableJsonArrayList = new ArrayList<Object>();
        replaceableJsonArrayList.add(replaceJson);

        taskData.put("replaceableJson", replaceableJsonArrayList);
        //AudioTrack支持
        HashMap<String, Object> audioTrack1 = new HashMap<String, Object>();
        audioTrack1.put("filePath", "http://static.atvideo.cc/2019/11/15/17/10/test.mp3");
        audioTrack1.put("inPoint", 35);
        audioTrack1.put("duration", 42);
        audioTrack1.put("startTime", 6);
        audioTrack1.put("endTime", 15);
        audioTrack1.put("loop", false);
        audioTrack1.put("volume", 1);

        ArrayList<Object> audioTracks = new ArrayList<Object>(){{
            this.add(audioTrack1);
        }};
        taskData.put("audioTracks", audioTracks);

        Cpr cpr = new Cpr(config);

        try {
            //在提交任务前，做一些基本的参数检查
            if (cpr.setTaskData(taskData)){
                String response = cpr.submit();
                if (response.equals("")) {
                    System.out.println("fail : " + response);
                } else {
                    System.out.println("recordId : " + recordId);
                    System.out.println("success : " + response);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    /****
     * 提交渲染任务接口文档 http://www.seeshiontech.com/docs/page_12.html
     */
    @Test
    public void testClipVideo() {
        Config config = new Config(accessKey, accessSecret, productId, ossId);

        HashMap<String, Object> taskData = new HashMap<String, Object>();


        taskData.put("recordId", "ui3cu2q801xn1pasda"); //该段商户订单号请您生成，确保唯一
        taskData.put("ossId", config.getOssId());
        taskData.put("notifyUrl", "http://www.seexon.com/render/callback");
        taskData.put("uploadKey", "user_video/881e338117c6f2cca993da5517b93fb8.mp4"); //视频渲染完毕后保存到您的oss平台中的路径
        taskData.put("width", 1280); //
        taskData.put("height", 720); //
        taskData.put("frameRate", 30); //

        ArrayList<Integer> t = new ArrayList<Integer>() {{
            this.add(1000);
            this.add(2000);
        }};
        ArrayList<Object> clips= new ArrayList<Object>() {{
            this.add(t);
        }};
        HashMap<String,Object> videoClip = new HashMap<String,Object>() {{
            this.put("fileUrl","https://vev-oss1.atvideo.cc/asset11.mp4");
            this.put("clips",clips);
        }};
        ArrayList<Object> videoClips = new ArrayList<Object>() {{
            this.add(videoClip);
        }};


        taskData.put("videoClips",videoClips);

        ClipVideo cpr = new ClipVideo(config);

        try {
            //在提交任务前，做一些基本的参数检查
            if (cpr.setTaskData(taskData)){
                String response = cpr.submit();
                if (response.equals("")) {
                    System.out.println("fail : " + response);
                } else {
                    System.out.println("success : " + response);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /****
     * 测试提交文字动画渲染模板
     */
    @Test
    public void testPowerText() {
        Config config = new Config(accessKey, accessSecret, productId, ossId);

        HashMap<String, Object> taskData = new HashMap<String, Object>();

        String recordId = UUID.randomUUID().toString().replace("-", "");


        taskData.put("tplId", 96);
        taskData.put("tplType", 1);
        taskData.put("tplVersion", 10);
        taskData.put("tplUrl", "http://static.seeshiontech.com/textanimate_normal_tpl.zip");
        taskData.put("recordId", recordId); //该段商户订单号请您生成，确保唯一
        taskData.put("musicUrl", "http://static.seeshiontech.com/photo_relay_album/video/yp_1.mp3");
        taskData.put("musicLoop", 1);
        taskData.put("ossId", config.getOssId());
        taskData.put("notifyUrl", "http://www.seexon.com/render/callback?a=1");
        taskData.put("uploadKey", "user_video/" + recordId + ".mp4"); //视频渲染完毕后保存到您的oss平台中的路径

        //replaceableJson 该参数存在时，引擎会自动忽略assetUrls、subTexts、subAssetUrls
        //详情查看文档 http://www.seeshiontech.com/docs/page_12.html
        //字符动画替换仅支持 replaceableJson字段传，需要注意动态模板和常规模板的格式不同
        //参见   http://www.seeshiontech.com/docs/page_178.html
        //      http://www.seeshiontech.com/docs/page_103.html

        HashMap<String, String> text1 = new HashMap<String, String>();
        text1.put("text", "字幕1");
        HashMap<String, Object> powerText1 = new HashMap<String, Object>();
        powerText1.put("power_text", text1);

        HashMap<String, String> text2 = new HashMap<String, String>();
        text2.put("text", "字幕2");
        HashMap<String, Object> powerText2 = new HashMap<String, Object>();
        powerText2.put("power_text", text2);

        HashMap<String, String> text3 = new HashMap<String, String>();
        text3.put("text", "字幕3");
        HashMap<String, Object> powerText3 = new HashMap<String, Object>();
        powerText3.put("power_text", text3);


        HashMap<String, String> replace1 = new HashMap<String, String>();
        replace1.put("main_file", "http://vei-oss1.atvideo.cc/2019/11/27/11/51/D614EBDA0B387F853C0999D2F1EEFD4C.jpg");

        HashMap<String, String> text4 = new HashMap<String, String>();
        text4.put("text", "字幕4");
        HashMap<String, Object> powerText4 = new HashMap<String, Object>();
        powerText4.put("power_text", text4);

        HashMap<String, String> replace2 = new HashMap<String, String>();
        replace2.put("main_file", "http://vei-oss1.atvideo.cc/2019/11/27/11/51/D614EBDA0B387F853C0999D2F1EEFD4C.jpg");


        ArrayList<Object> replaces = new ArrayList<Object>(){{
            this.add(powerText1);
            this.add(powerText2);
            this.add(powerText3);
            this.add(replace1);
            this.add(powerText4);
            this.add(replace2);
        }};

        taskData.put("replaceableJson", replaces);
        //开启对powerText支持
        taskData.put("setting", RenderType.COMMON_TEMPLATE.getValue() | RenderType.POWER_TEXT.getValue());


        Cpr cpr = new Cpr(config);

        try {
            //在提交任务前，做一些基本的参数检查
            if (cpr.setTaskData(taskData)){
                String response = cpr.submit();
                if (response.equals("")) {
                    System.out.println("fail : " + response);
                } else {
                    System.out.println("recordId : " + recordId);
                    System.out.println("success : " + response);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
